<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrailerSubGroupItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfTrailerSubGroupItem extends AbstractStructArrayBase
{
    /**
     * The TrailerSubGroupItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrailerSubGroupItem[]
     */
    public $TrailerSubGroupItem;
    /**
     * Constructor method for ArrayOfTrailerSubGroupItem
     * @uses ArrayOfTrailerSubGroupItem::setTrailerSubGroupItem()
     * @param \StructType\TrailerSubGroupItem[] $trailerSubGroupItem
     */
    public function __construct(array $trailerSubGroupItem = array())
    {
        $this
            ->setTrailerSubGroupItem($trailerSubGroupItem);
    }
    /**
     * Get TrailerSubGroupItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrailerSubGroupItem[]|null
     */
    public function getTrailerSubGroupItem()
    {
        return isset($this->TrailerSubGroupItem) ? $this->TrailerSubGroupItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTrailerSubGroupItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTrailerSubGroupItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTrailerSubGroupItemForArrayConstraintsFromSetTrailerSubGroupItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTrailerSubGroupItemTrailerSubGroupItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfTrailerSubGroupItemTrailerSubGroupItemItem instanceof \StructType\TrailerSubGroupItem) {
                $invalidValues[] = is_object($arrayOfTrailerSubGroupItemTrailerSubGroupItemItem) ? get_class($arrayOfTrailerSubGroupItemTrailerSubGroupItemItem) : sprintf('%s(%s)', gettype($arrayOfTrailerSubGroupItemTrailerSubGroupItemItem), var_export($arrayOfTrailerSubGroupItemTrailerSubGroupItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TrailerSubGroupItem property can only contain items of type \StructType\TrailerSubGroupItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TrailerSubGroupItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TrailerSubGroupItem[] $trailerSubGroupItem
     * @return \ArrayType\ArrayOfTrailerSubGroupItem
     */
    public function setTrailerSubGroupItem(array $trailerSubGroupItem = array())
    {
        // validation for constraint: array
        if ('' !== ($trailerSubGroupItemArrayErrorMessage = self::validateTrailerSubGroupItemForArrayConstraintsFromSetTrailerSubGroupItem($trailerSubGroupItem))) {
            throw new \InvalidArgumentException($trailerSubGroupItemArrayErrorMessage, __LINE__);
        }
        if (is_null($trailerSubGroupItem) || (is_array($trailerSubGroupItem) && empty($trailerSubGroupItem))) {
            unset($this->TrailerSubGroupItem);
        } else {
            $this->TrailerSubGroupItem = $trailerSubGroupItem;
        }
        return $this;
    }
    /**
     * Add item to TrailerSubGroupItem value
     * @throws \InvalidArgumentException
     * @param \StructType\TrailerSubGroupItem $item
     * @return \ArrayType\ArrayOfTrailerSubGroupItem
     */
    public function addToTrailerSubGroupItem(\StructType\TrailerSubGroupItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TrailerSubGroupItem) {
            throw new \InvalidArgumentException(sprintf('The TrailerSubGroupItem property can only contain items of type \StructType\TrailerSubGroupItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TrailerSubGroupItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TrailerSubGroupItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TrailerSubGroupItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TrailerSubGroupItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TrailerSubGroupItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TrailerSubGroupItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrailerSubGroupItem
     */
    public function getAttributeName()
    {
        return 'TrailerSubGroupItem';
    }
}
